Index: admin/js/jsToolBar/jsToolBar.dotclear.js
===================================================================
--- admin/js/jsToolBar/jsToolBar.dotclear.js	(revision 0)
+++ admin/js/jsToolBar/jsToolBar.dotclear.js	(revision 0)
@@ -0,0 +1,378 @@
+/* Change link button actions
+-------------------------------------------------------- */
+jsToolBar.prototype.elements.link.data = {};
+jsToolBar.prototype.elements.link.fncall = {};
+jsToolBar.prototype.elements.link.open_url = 'popup_link.php';
+
+jsToolBar.prototype.elements.link.popup = function (args) {
+	window.the_toolbar = this;
+	args = args || '';
+	
+	this.elements.link.data = {};
+	var url = this.elements.link.open_url+args;
+	
+	var p_win = window.open(url,'dc_popup',
+	'alwaysRaised=yes,dependent=yes,toolbar=yes,height=420,width=380,'+
+	'menubar=no,resizable=yes,scrollbars=yes,status=no');
+};
+
+jsToolBar.prototype.elements.link.fn.wiki = function() {
+	this.elements.link.popup.call(this,'?hreflang='+this.elements.link.default_hreflang);
+};
+jsToolBar.prototype.elements.link.fncall.wiki = function() {
+	var data = this.elements.link.data;
+	
+	if (data.href == '') { return; }
+	
+	var etag = '|'+data.href;
+	if (data.hreflang) { etag += '|'+data.hreflang; }
+	
+	if (data.title) {
+		if (!data.hreflang) { etag += '|'; }
+		etag += '|'+data.title;
+	}
+	
+	if (data.content) {
+		this.encloseSelection('['+data.content,etag+']');
+	} else {
+		this.encloseSelection('[',etag+']');
+	}
+};
+
+jsToolBar.prototype.elements.link.fn.xhtml = function() {
+	this.elements.link.popup.call(this,'?hreflang='+this.elements.link.default_hreflang);
+};
+jsToolBar.prototype.elements.link.fncall.xhtml = function() {
+	var data = this.elements.link.data;
+	
+	if (data.href == '') { return; }
+	
+	var stag = '<a href="'+data.href+'"';
+	
+	if (data.hreflang) { stag += ' hreflang="'+data.hreflang+'"'; }
+	if (data.title) { stag += ' title="'+data.title+'"'; }
+	stag += '>';
+	var etag = '</a>';
+	
+	if (data.content) {
+		this.encloseSelection('','',function() {
+			return stag + data.content + etag;
+		});
+	} else {
+		this.encloseSelection(stag,etag);
+	}
+};
+
+jsToolBar.prototype.elements.link.fn.wysiwyg = function() {
+	var href, title, hreflang;
+	href = title = hreflang = '';
+	hreflang = this.elements.link.default_hreflang;
+	
+	var a = this.getAncestor();
+	
+	if (a.tagName == 'a') {
+		href= a.tag.href || '';
+		title = a.tag.title || '';
+		hreflang = a.tag.hreflang || '';
+	}
+	
+	this.elements.link.popup.call(this,'?href='+href+'&hreflang='+hreflang+'&title='+title);
+};
+jsToolBar.prototype.elements.link.fncall.wysiwyg = function() {
+	var data = this.elements.link.data;
+	
+	var a = this.getAncestor();
+	
+	if (a.tagName == 'a') {
+		if (data.href == '') {
+			// Remove link
+			this.replaceNodeByContent(a.tag);
+			this.iwin.focus();
+			return;
+		} else {
+			// Update link
+			a.tag.href = data.href;
+			if (data.hreflang) {
+				a.tag.setAttribute('hreflang',data.hreflang);
+			} else {
+				a.tag.removeAttribute('hreflang');
+			}
+			if (data.title) {
+				a.tag.setAttribute('title',data.title);
+			} else {
+				a.tag.removeAttribute('title');
+			}
+			return;
+		}
+	}
+	
+	// Create link
+	if (data.content) {
+		var n = document.createTextNode(data.content);
+	} else {
+		var n = this.getSelectedNode();
+	}
+	var a = this.iwin.document.createElement('a');
+	a.href = data.href;
+	if (data.hreflang) a.setAttribute('hreflang',data.hreflang);
+	a.appendChild(n);
+	this.insertNode(a);
+};
+jsToolBar.prototype.getAncestor = function() {
+	var res = {};
+	var range, commonAncestorContainer;
+	
+	if (this.iwin.getSelection) { //gecko
+		var selection = this.iwin.getSelection();
+		range = selection.getRangeAt(0);
+		commonAncestorContainer = range.commonAncestorContainer;
+		while (commonAncestorContainer.nodeType != 1) {
+			commonAncestorContainer = commonAncestorContainer.parentNode;
+		}
+	} else { //ie
+		range = this.iwin.document.selection.createRange();
+		commonAncestorContainer = range.parentElement();
+	}
+	
+	var ancestorTagName = commonAncestorContainer.tagName.toLowerCase();
+	while (ancestorTagName!='a' && ancestorTagName!='body') {
+		commonAncestorContainer = commonAncestorContainer.parentNode;
+		ancestorTagName = commonAncestorContainer.tagName.toLowerCase();
+	}
+	
+	res.tag = commonAncestorContainer;
+	res.tagName = ancestorTagName;
+	
+	return res;
+};
+
+/* Image selector
+-------------------------------------------------------- */
+jsToolBar.prototype.elements.img_select = {
+	type: 'button',
+	title: 'Image chooser',
+	fn: {},
+	fncall: {},
+	open_url: 'media.php?popup=1',
+	data: {},
+	popup: function() {
+		window.the_toolbar = this;
+		this.elements.img_select.data = {};
+		
+		var p_win = window.open(this.elements.img_select.open_url,'dc_popup',
+		'alwaysRaised=yes,dependent=yes,toolbar=yes,height=500,width=760,'+
+		'menubar=no,resizable=yes,scrollbars=yes,status=no');
+	}
+};
+jsToolBar.prototype.elements.img_select.fn.wiki = function() {
+	this.elements.img_select.popup.call(this);
+};
+jsToolBar.prototype.elements.img_select.fncall.wiki = function() {
+	var d = this.elements.img_select.data;
+	if (d.src == undefined) { return; }
+	
+	this.encloseSelection('','',function(str) {
+		var alt = (str) ? str : d.title;
+		var res = '(('+d.src+'|'+alt;
+		
+		if (d.alignment == 'left') {
+			res += '|L';
+		} else if (d.alignment == 'right') {
+			res += '|R';
+		} else if (d.alignment == 'center') {
+			res += '|C';
+		} else if (d.description) {
+			res += '|';
+		}
+		
+		if (d.description) {
+			res += '|'+d.description;
+		}
+		
+		res += '))';
+		
+		if (d.link) {
+			var ltitle = (alt) ? '||'+alt : '';
+			res = '['+res+'|'+d.url+ltitle+']';
+		}
+		
+		return res;
+	});
+};
+jsToolBar.prototype.elements.img_select.fn.xhtml = function() {
+	this.elements.img_select.popup.call(this);
+};
+jsToolBar.prototype.elements.img_select.fncall.xhtml = function() {
+	var d = this.elements.img_select.data;
+	if (d.src == undefined) { return; }
+	
+	this.encloseSelection('','',function(str) {
+		var alt = (str) ? str : d.title;
+		var res = '<img src="'+d.src+'" alt="'+alt.replace('&','&amp;').replace('>','&gt;').replace('<','&lt;').replace('"','&quot;')+'"';
+		
+		if (d.alignment == 'left') {
+			res += ' style="float: left; margin: 0 1em 1em 0;"';
+		} else if (d.alignment == 'right') {
+			res += ' style="float: right; margin: 0 0 1em 1em;"';
+		} else if (d.alignment == 'center') {
+			res += ' style="margin: 0 auto; display: block;"';
+		}
+		
+		if (d.description) {
+			res += ' title="'+d.description.replace('&','&amp;').replace('>','&gt;').replace('<','&lt;').replace('"','&quot;')+'"';
+		}
+		
+		res += ' />';
+		
+		if (d.link) {
+			var ltitle = (alt) ? ' title="'+alt.replace('&','&amp;').replace('>','&gt;').replace('<','&lt;').replace('"','&quot;')+'"' : '';
+			res = '<a href="'+d.url+'"'+ltitle+'>'+res+'</a>';
+		}
+		
+		return res;
+	});
+};
+
+jsToolBar.prototype.elements.img.fn.wysiwyg = function() {
+	var src = this.elements.img.prompt.call(this);
+	if (!src) { return; }
+	
+	var img = this.iwin.document.createElement('img');
+	img.src = src;
+	img.setAttribute('alt',this.getSelectedText());
+	
+	this.insertNode(img);
+};
+
+jsToolBar.prototype.elements.img_select.fn.wysiwyg = function() {
+	this.elements.img_select.popup.call(this);
+};
+jsToolBar.prototype.elements.img_select.fncall.wysiwyg = function() {
+	var d = this.elements.img_select.data;
+	var alt = (this.getSelectedText()) ? this.getSelectedText() : d.title;
+	if (d.src == undefined) { return; }
+	
+	var img = this.iwin.document.createElement('img');
+	img.src = d.src;
+	img.setAttribute('alt',alt);
+	
+	
+	if (d.alignment == 'left') {
+		if (img.style.styleFloat != undefined) {
+			img.style.styleFloat = 'left';
+		} else {
+			img.style.cssFloat = 'left';
+		}
+		img.style.marginTop = 0;
+		img.style.marginRight = '1em';
+		img.style.marginBottom = '1em';
+		img.style.marginLeft = 0;
+	} else if (d.alignment == 'right') {
+		if (img.style.styleFloat != undefined) {
+			img.style.styleFloat = 'right';
+		} else {
+			img.style.cssFloat = 'right';
+		}
+		img.style.marginTop = 0;
+		img.style.marginRight = 0;
+		img.style.marginBottom = '1em';
+		img.style.marginLeft = '1em';
+	} else if (d.alignment == 'center') {
+		img.style.marginTop = 0;
+		img.style.marginRight = 'auto';
+		img.style.marginBottom = 0;
+		img.style.marginLeft = 'auto';
+		img.style.display = 'block';
+	}
+	
+	if (d.description) {
+		img.setAttribute('title',d.description);
+	}
+	
+	if (d.link) {
+		var a = this.iwin.document.createElement('a');
+		a.href = d.url;
+		if (alt) {
+			a.setAttribute('title',alt);
+		}
+		a.appendChild(img);
+		this.insertNode(a);
+	} else {
+		this.insertNode(img);
+	}
+};
+
+// MP3 helpers
+jsToolBar.prototype.elements.mp3_insert = { fncall: {}, data: {} };
+jsToolBar.prototype.elements.mp3_insert.fncall.wiki = function() {
+	var d = this.elements.mp3_insert.data;
+	if (d.player == undefined) { return; }
+	
+	this.encloseSelection('','',function(str) {
+		return '\n///html\n' + d.player + '///\n';
+	});
+};
+jsToolBar.prototype.elements.mp3_insert.fncall.xhtml = function() {
+	var d = this.elements.mp3_insert.data;
+	if (d.player == undefined) { return; }
+	
+	this.encloseSelection('','',function(str) {
+		return '\n' + d.player + '\n';
+	});
+};
+jsToolBar.prototype.elements.mp3_insert.fncall.wysiwyg = function() {
+	return;
+};
+
+// FLV helpers
+jsToolBar.prototype.elements.flv_insert = { fncall: {}, data: {} };
+jsToolBar.prototype.elements.flv_insert.fncall.wiki = function() {
+	var d = this.elements.flv_insert.data;
+	if (d.player == undefined) { return; }
+	
+	this.encloseSelection('','',function(str) {
+		return '\n///html\n' + d.player + '///\n';
+	});
+};
+jsToolBar.prototype.elements.flv_insert.fncall.xhtml = function() {
+	var d = this.elements.flv_insert.data;
+	if (d.player == undefined) { return; }
+	
+	this.encloseSelection('','',function(str) {
+		return '\n' + d.player + '\n';
+	});
+};
+jsToolBar.prototype.elements.flv_insert.fncall.wysiwyg = function() {
+	return;
+};
+
+
+/* Posts selector
+-------------------------------------------------------- */
+jsToolBar.prototype.elements.post_link = {
+	type: 'button',
+	title: 'Link to an entry',
+	fn: {},
+	open_url: 'popup_posts.php',
+	data: {},
+	popup: function() {
+		window.the_toolbar = this;
+		this.elements.img_select.data = {};
+		
+		var p_win = window.open(this.elements.post_link.open_url,'dc_popup',
+		'alwaysRaised=yes,dependent=yes,toolbar=yes,height=500,width=760,'+
+		'menubar=no,resizable=yes,scrollbars=yes,status=no');
+	}
+};
+jsToolBar.prototype.elements.post_link.fn.wiki = function() {
+	this.elements.post_link.popup.call(this);
+};
+jsToolBar.prototype.elements.post_link.fn.xhtml = function() {
+	this.elements.post_link.popup.call(this);
+};
+jsToolBar.prototype.elements.post_link.fn.wysiwyg = function() {
+	this.elements.post_link.popup.call(this);
+};
+
+// Last space element
+jsToolBar.prototype.elements.space3 = {type: 'space'};
Index: admin/js/jsToolBar/jsToolBar.js
===================================================================
--- admin/js/jsToolBar/jsToolBar.js	(revision 0)
+++ admin/js/jsToolBar/jsToolBar.js	(revision 0)
@@ -0,0 +1,581 @@
+/* ***** BEGIN LICENSE BLOCK *****
+ * This file is part of DotClear.
+ * Copyright (c) 2005 Nicolas Martin & Olivier Meunier and contributors. All
+ * rights reserved.
+ *
+ * DotClear is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ * 
+ * DotClear is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License
+ * along with DotClear; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * ***** END LICENSE BLOCK *****
+*/
+
+function jsToolBar(textarea) {
+	if (!document.createElement) { return; }
+	
+	if (!textarea) { return; }
+	
+	if ((typeof(document["selection"]) == "undefined")
+	&& (typeof(textarea["setSelectionRange"]) == "undefined")) {
+		return;
+	}
+	
+	this.textarea = textarea;
+	
+	this.editor = document.createElement('div');
+	this.editor.className = 'jstEditor';
+	
+	this.textarea.parentNode.insertBefore(this.editor,this.textarea);
+	this.editor.appendChild(this.textarea);
+	
+	this.toolbar = document.createElement("div");
+	this.toolbar.className = 'jstElements';
+	this.editor.parentNode.insertBefore(this.toolbar,this.editor);
+	
+	// Dragable resizing (only for gecko)
+	if (this.editor.addEventListener)
+	{
+		this.handle = document.createElement('div');
+		this.handle.className = 'jstHandle';
+		var dragStart = this.resizeDragStart;
+		var This = this;
+		this.handle.addEventListener('mousedown',function(event) { dragStart.call(This,event); },false);
+		// fix memory leak in Firefox (bug #241518)
+		window.addEventListener('unload',function() {
+				var del = This.handle.parentNode.removeChild(This.handle);
+				delete(This.handle);
+		},false);
+		
+		this.editor.parentNode.insertBefore(this.handle,this.editor.nextSibling);
+	}
+	
+	this.context = null;
+	this.toolNodes = {}; // lorsque la toolbar est dessinée , cet objet est garni 
+					// de raccourcis vers les éléments DOM correspondants aux outils.
+};
+
+function jsButton(title, fn, scope, className) {
+	this.title = title || null;
+	this.fn = fn || function(){};
+	this.scope = scope || null;
+	this.className = className || null;
+};
+jsButton.prototype.draw = function() {
+	if (!this.scope) return null;
+	
+	var button = document.createElement('button');
+	button.setAttribute('type','button');
+	if (this.className) button.className = this.className;
+	button.title = this.title;
+	var span = document.createElement('span');
+	span.appendChild(document.createTextNode(this.title));
+	button.appendChild(span);
+	
+	if (this.icon != undefined) {
+		button.style.backgroundImage = 'url('+this.icon+')';
+	}
+	if (typeof(this.fn) == 'function') {
+		var This = this;
+		button.onclick = function() { try { This.fn.apply(This.scope, arguments) } catch (e) {} return false; };
+	}
+	return button;
+};
+
+function jsSpace(id) {
+	this.id = id || null;
+	this.width = null;
+};
+jsSpace.prototype.draw = function() {
+	var span = document.createElement('span');
+	if (this.id) span.id = this.id;
+	span.appendChild(document.createTextNode(String.fromCharCode(160)));
+	span.className = 'jstSpacer';
+	if (this.width) span.style.marginRight = this.width+'px';
+	
+	return span;
+};
+
+function jsCombo(title, options, scope, fn, className) {
+	this.title = title || null;
+	this.options = options || null;
+	this.scope = scope || null;
+	this.fn = fn || function(){};
+	this.className = className || null;
+};
+jsCombo.prototype.draw = function() {
+	if (!this.scope || !this.options) return null;
+	
+	var select = document.createElement('select');
+	if (this.className) select.className = className;
+	select.title = this.title;
+	
+	for (var o in this.options) {
+		//var opt = this.options[o];
+		var option = document.createElement('option');
+		option.value = o;
+		option.appendChild(document.createTextNode(this.options[o]));
+		select.appendChild(option);
+	}
+	
+	var This = this;
+	select.onchange = function() {
+		try { 
+			This.fn.call(This.scope, this.value);
+		} catch (e) { alert(e); }
+		
+		return false;
+	};
+	
+	return select;
+};
+
+
+jsToolBar.prototype = {
+	base_url: '',
+	mode: 'xhtml',
+	elements: {},
+	
+	getMode: function() {
+		return this.mode;
+	},
+	
+	setMode: function(mode) {
+		this.mode = mode || 'xhtml';
+	},
+	
+	switchMode: function(mode) {
+		mode = mode || 'xhtml';
+		this.draw(mode);
+	},
+	
+	button: function(toolName) {
+		var tool = this.elements[toolName];
+		if (typeof tool.fn[this.mode] != 'function') return null;
+		var b = new jsButton(tool.title, tool.fn[this.mode], this, 'jstb_'+toolName);
+		if (tool.icon != undefined) {
+			b.icon = tool.icon;
+		}
+		return b;
+	},
+	space: function(toolName) {
+		var tool = new jsSpace(toolName);
+		if (this.elements[toolName].width !== undefined) {
+			tool.width = this.elements[toolName].width;
+		}
+		return tool;
+	},
+	combo: function(toolName) {
+		var tool = this.elements[toolName];
+		var length = tool[this.mode].list.length;
+		
+		if (typeof tool[this.mode].fn != 'function' || length == 0) {
+			return null;
+		} else {
+			var options = {};
+			for (var i=0; i < length; i++) {
+				var opt = tool[this.mode].list[i];
+				options[opt] = tool.options[opt];
+			}
+			return new jsCombo(tool.title, options, this, tool[this.mode].fn);
+		}
+	},
+	draw: function(mode) {
+		this.setMode(mode);
+		
+		// Empty toolbar
+		while (this.toolbar.hasChildNodes()) {
+			this.toolbar.removeChild(this.toolbar.firstChild)
+		}
+		this.toolNodes = {}; // vide les raccourcis DOM/**/
+		
+		// Draw toolbar elements
+		var b, tool, newTool;
+		
+		for (var i in this.elements) {
+			b = this.elements[i];
+			
+			var disabled =
+			b.type == undefined || b.type == ''
+			|| (b.disabled != undefined && b.disabled)
+			|| (b.context != undefined && b.context != null && b.context != this.context);
+			
+			if (!disabled && typeof this[b.type] == 'function') {
+				tool = this[b.type](i);
+				if (tool) newTool = tool.draw();
+				if (newTool) {
+					this.toolNodes[i] = newTool; //mémorise l'accès DOM pour usage éventuel ultérieur
+					this.toolbar.appendChild(newTool);
+				}
+			}
+		}
+	},
+	
+	singleTag: function(stag,etag) {
+		stag = stag || null;
+		etag = etag || stag;
+		
+		if (!stag || !etag) { return; }
+		
+		this.encloseSelection(stag,etag);
+	},
+	
+	encloseSelection: function(prefix, suffix, fn) {
+		this.textarea.focus();
+		
+		prefix = prefix || '';
+		suffix = suffix || '';
+		
+		var start, end, sel, scrollPos, subst, res;
+		
+		if (typeof(document["selection"]) != "undefined") {
+			sel = document.selection.createRange().text;
+		} else if (typeof(this.textarea["setSelectionRange"]) != "undefined") {
+			start = this.textarea.selectionStart;
+			end = this.textarea.selectionEnd;
+			scrollPos = this.textarea.scrollTop;
+			sel = this.textarea.value.substring(start, end);
+		}
+		
+		if (sel.match(/ $/)) { // exclude ending space char, if any
+			sel = sel.substring(0, sel.length - 1);
+			suffix = suffix + " ";
+		}
+		
+		if (typeof(fn) == 'function') {
+			res = (sel) ? fn.call(this,sel) : fn('');
+		} else {
+			res = (sel) ? sel : '';
+		}
+		
+		subst = prefix + res + suffix;
+		
+		if (typeof(document["selection"]) != "undefined") {
+			var range = document.selection.createRange().text = subst;
+			this.textarea.caretPos -= suffix.length;
+		} else if (typeof(this.textarea["setSelectionRange"]) != "undefined") {
+			this.textarea.value = this.textarea.value.substring(0, start) + subst +
+			this.textarea.value.substring(end);
+			if (sel) {
+				this.textarea.setSelectionRange(start + subst.length, start + subst.length);
+			} else {
+				this.textarea.setSelectionRange(start + prefix.length, start + prefix.length);
+			}
+			this.textarea.scrollTop = scrollPos;
+		}
+	},
+	
+	stripBaseURL: function(url) {
+		if (this.base_url != '') {
+			var pos = url.indexOf(this.base_url);
+			if (pos == 0) {
+				url = url.substr(this.base_url.length);
+			}
+		}
+		
+		return url;
+	}
+};
+
+/** Resizer
+-------------------------------------------------------- */
+jsToolBar.prototype.resizeSetStartH = function() {
+	this.dragStartH = this.textarea.offsetHeight + 0;
+};
+jsToolBar.prototype.resizeDragStart = function(event) {
+	var This = this;
+	this.dragStartY = event.clientY;
+	this.resizeSetStartH();
+	document.addEventListener('mousemove', this.dragMoveHdlr=function(event){This.resizeDragMove(event);}, false);
+	document.addEventListener('mouseup', this.dragStopHdlr=function(event){This.resizeDragStop(event);}, false);
+};
+
+jsToolBar.prototype.resizeDragMove = function(event) {
+	this.textarea.style.height = (this.dragStartH+event.clientY-this.dragStartY)+'px';
+};
+
+jsToolBar.prototype.resizeDragStop = function(event) {
+	document.removeEventListener('mousemove', this.dragMoveHdlr, false);
+	document.removeEventListener('mouseup', this.dragStopHdlr, false);
+};
+
+// Elements definition ------------------------------------
+// block format (paragraph, headers)
+jsToolBar.prototype.elements.blocks = {
+	type: 'combo',
+	title: 'block format',
+	options: {
+		none: '-- none --', // only for wysiwyg mode
+		nonebis: '- block format -', // only for xhtml mode
+		p: 'Paragraph',
+		h1: 'Header 1',
+		h2: 'Header 2',
+		h3: 'Header 3',
+		h4: 'Header 4',
+		h5: 'Header 5',
+		h6: 'Header 6'
+	},
+	xhtml: {
+		list: ['nonebis','p','h1','h2','h3','h4','h5','h6'],
+		fn: function(opt) {
+			if (opt=='nonebis')
+				this.textarea.focus();
+			else
+				try {this.singleTag('<'+opt+'>','</'+opt+'>');} catch(e){};
+			this.toolNodes.blocks.value = 'nonebis';
+		}
+	},
+	wiki: {
+		list: ['nonebis','h2','h3','h4','h5'],
+		fn: function(opt) {
+			switch (opt) {
+				case 'nonebis': this.textarea.focus(); break;
+				case 'h2': this.encloseSelection('!!!!'); break;
+				case 'h3': this.encloseSelection('!!!'); break;
+				case 'h4': this.encloseSelection('!!'); break;
+				case 'h5': this.encloseSelection('!'); break;
+			}
+			this.toolNodes.blocks.value = 'nonebis';
+		}
+	}
+};
+
+// spacer
+jsToolBar.prototype.elements.space0 = {type: 'space'};
+
+// strong
+jsToolBar.prototype.elements.strong = {
+	type: 'button',
+	title: 'Strong emphasis',
+	fn: {
+		wiki: function() { this.singleTag('__') },
+		xhtml: function() { this.singleTag('<strong>','</strong>') }
+	}
+};
+
+// em
+jsToolBar.prototype.elements.em = {
+	type: 'button',
+	title: 'Emphasis',
+	fn: {
+		wiki: function() { this.singleTag("''") },
+		xhtml: function() { this.singleTag('<em>','</em>') }
+	}
+};
+
+// ins
+jsToolBar.prototype.elements.ins = {
+	type: 'button',
+	title: 'Inserted',
+	fn: {
+		wiki: function() { this.singleTag('++') },
+		xhtml: function() { this.singleTag('<ins>','</ins>') }
+	}
+};
+
+// del
+jsToolBar.prototype.elements.del = {
+	type: 'button',
+	title: 'Deleted',
+	fn: {
+		wiki: function() { this.singleTag('--') },
+		xhtml: function() { this.singleTag('<del>','</del>') }
+	}
+};
+
+// quote
+jsToolBar.prototype.elements.quote = {
+	type: 'button',
+	title: 'Inline quote',
+	fn: {
+		wiki: function() { this.singleTag('{{','}}') },
+		xhtml: function() { this.singleTag('<q>','</q>') }
+	}
+};
+
+// code
+jsToolBar.prototype.elements.code = {
+	type: 'button',
+	title: 'Code',
+	fn: {
+		wiki: function() { this.singleTag('@@') },
+		xhtml: function() { this.singleTag('<code>','</code>')}
+	}
+};
+
+// spacer
+jsToolBar.prototype.elements.space1 = {type: 'space'};
+
+// br
+jsToolBar.prototype.elements.br = {
+	type: 'button',
+	title: 'Line break',
+	fn: {
+		wiki: function() { this.encloseSelection("%%%\n",'') },
+		xhtml: function() { this.encloseSelection("<br />\n",'')}
+	}
+};
+
+// spacer
+jsToolBar.prototype.elements.space2 = {type: 'space'};
+
+// blockquote
+jsToolBar.prototype.elements.blockquote = {
+	type: 'button',
+	title: 'Blockquote',
+	fn: {
+		xhtml: function() { this.singleTag('<blockquote>','</blockquote>') },
+		wiki: function() {
+			this.encloseSelection("\n",'',
+			function(str) {
+				str = str.replace(/\r/g,'');
+				return '> '+str.replace(/\n/g,"\n> ");
+			});
+		}
+	}
+};
+
+// pre
+jsToolBar.prototype.elements.pre = {
+	type: 'button',
+	title: 'Preformated text',
+	fn: {
+		wiki: function() { this.singleTag("///\n","\n///") },
+		xhtml: function() { this.singleTag('<pre>','</pre>') }
+	}
+};
+
+// ul
+jsToolBar.prototype.elements.ul = {
+	type: 'button',
+	title: 'Unordered list',
+	fn: {
+		wiki: function() {
+			this.encloseSelection('','',function(str) {
+				str = str.replace(/\r/g,'');
+				return '* '+str.replace(/\n/g,"\n* ");
+			});
+		},
+		xhtml: function() {
+			this.encloseSelection('','',function(str) {
+				str = str.replace(/\r/g,'');
+				str = str.replace(/\n/g,"</li>\n <li>");
+				return "<ul>\n <li>"+str+"</li>\n</ul>";
+			});
+		}
+	}
+};
+
+// ol
+jsToolBar.prototype.elements.ol = {
+	type: 'button',
+	title: 'Ordered list',
+	fn: {
+		wiki: function() {
+			this.encloseSelection('','',function(str) {
+				str = str.replace(/\r/g,'');
+				return '# '+str.replace(/\n/g,"\n# ");
+			});
+		},
+		xhtml: function() {
+			this.encloseSelection('','',function(str) {
+				str = str.replace(/\r/g,'');
+				str = str.replace(/\n/g,"</li>\n <li>");
+				return "<ol>\n <li>"+str+"</li>\n</ol>";
+			});
+		}
+	}
+};
+
+// spacer
+jsToolBar.prototype.elements.space3 = {type: 'space'};
+
+// link
+jsToolBar.prototype.elements.link = {
+	type: 'button',
+	title: 'Link',
+	fn: {},
+	href_prompt: 'Please give page URL:',
+	hreflang_prompt: 'Language of this page:',
+	default_hreflang: '',
+	prompt: function(href,hreflang) {
+		href = href || '';
+		hreflang = hreflang || this.elements.link.default_hreflang;
+		
+		href = window.prompt(this.elements.link.href_prompt,href);
+		if (!href) { return false; }
+		
+		hreflang = window.prompt(this.elements.link.hreflang_prompt,
+		hreflang);
+		
+		return { href: this.stripBaseURL(href), hreflang: hreflang };
+	}
+};
+
+jsToolBar.prototype.elements.link.fn.xhtml = function() {
+	var link = this.elements.link.prompt.call(this);
+	if (link) {
+		var stag = '<a href="'+link.href+'"';
+		if (link.hreflang) { stag = stag+' hreflang="'+link.hreflang+'"'; }
+		stag = stag+'>';
+		var etag = '</a>';
+		
+		this.encloseSelection(stag,etag);
+	}
+};
+jsToolBar.prototype.elements.link.fn.wiki = function() {
+	var link = this.elements.link.prompt.call(this);
+	if (link) {
+		var stag = '[';
+		var etag = '|'+link.href;
+		if (link.hreflang) { etag = etag+'|'+link.hreflang; }
+		etag = etag+']';
+		
+		this.encloseSelection(stag,etag);
+	}
+};
+
+// img
+jsToolBar.prototype.elements.img = {
+		type: 'button',
+		title: 'External image',
+		src_prompt: 'Please give image URL:',
+		fn: {},
+		prompt: function(src) {
+			src = src || '';
+			return this.stripBaseURL(window.prompt(this.elements.img.src_prompt,src));
+		}
+};
+jsToolBar.prototype.elements.img.fn.xhtml = function() {
+	var src = this.elements.img.prompt.call(this);
+	if (src) {
+		this.encloseSelection('','',function(str) {
+			if (str) {
+				return '<img src="'+src+'" alt="'+str+'" />';
+			} else {
+				return '<img src="'+src+'" alt="" />';
+			}
+		});
+	}
+};
+jsToolBar.prototype.elements.img.fn.wiki = function() {
+	var src = this.elements.img.prompt.call(this);
+	if (src) {
+		this.encloseSelection('','',function(str) {
+			if (str) {
+				return '(('+src+'|'+str+'))';
+			} else {
+				return '(('+src+'))';
+			}
+		});
+	}
+};
